;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux ddskk package
;;
;; Originally contributed by Nils Naumann <naumann@unileoben.ac.at>
;; Modified by Dirk Eddelbuettel <edd@debian.org>
;; Adapted for dh-make by Jim Van Zandt <jrv@vanzandt.mv.com>

;; The ddskk package follows the Debian/GNU Linux 'emacsen' policy and
;; byte-compiles its elisp files for each 'emacs flavor' (emacs19,
;; xemacs19, emacs20, xemacs20...).  The compiled code is then
;; installed in a subdirectory of the respective site-lisp directory.
;; We have to add this to the load-path:
(setq load-path (nconc load-path (list (concat "/usr/share/"
                                               (symbol-name flavor)
                                               "/site-lisp/ddskk"))))

(global-set-key "\C-x\C-j" 'skk-mode)
(global-set-key "\C-xj" 'skk-auto-fill-mode)
(add-hook 'isearch-mode-hook
          (function (lambda ()
                      (and (boundp 'skk-mode) skk-mode
                           (skk-isearch-mode-setup)))))
(add-hook 'isearch-mode-end-hook
     	  (function
     	   (lambda ()
     	     (and (boundp 'skk-mode)
                  skk-mode
                  (skk-isearch-mode-cleanup))
     	     (and (boundp 'skk-mode-invoked)
                  skk-mode-invoked
     		  (skk-cursor-set-properly)))))
(add-hook 'minibuffer-setup-hook
          (function (lambda ()
                      (if (and (boundp 'skk-henkan-okuri-strictly)
                               skk-henkan-okuri-strictly
                               (not (eq last-command 'skk-purge-jisyo)))
                          (progn
                            (setq skk-henkan-okuri-strictly nil)
                            (put 'skk-henkan-okuri-strictly 'temporary-nil t))))))
(add-hook 'minibuffer-exit-hook
          (function (lambda ()
                      (if (get 'skk-henkan-okuri-strictly 'temporary-nil)
                          (progn
                            (put 'skk-henkan-okuri-strictly 'temporary-nil nil)
                            (setq skk-henkan-okuri-strictly t))))))

(setq skk-server-host "localhost")
(setq skk-tut-file "/usr/share/skk/SKK.tut")

(load "skk-autoloads")
